(defvar carbon-win-initted nil)
(defvar carbon-pre-win-initted nil)
(defvar carbon-post-win-initted nil)

(defun init-pre-carbon-win ()
  "Initialize Carbon GUI at startup (pre).  Don't call this."
  (unless carbon-pre-win-initted
    (setq carbon-pre-win-initted t)))

(defun init-carbon-win ()
  "Initialize carbon GUI at startup.  Don't call this."
  (unless carbon-win-initted
    (init-pre-carbon-win)
    (make-carbon-device)
    (init-post-carbon-win (selected-console))

    ;; If Emacs is started from the Finder, change the default directory
    ;; to the user's home directory.
    (if (string= default-directory "/")
	(cd "~"))

    (setq carbon-win-initted t)))

(defun init-post-carbon-win (console)
  "Initialize carbon GUI at startup (post).  Don't call this."
  (unless carbon-post-win-initted
    (setq carbon-post-win-initted t)))
