/*
 The following code is original work by me, except where noted with
 the comments "Taken from ..." or "Adapted from ...".  I now place
 it in the public domain.
 
 Andrew Choi.  Calgary, Canada, February 9, 2005. */

#ifndef INCLUDED_console_carbon_impl_h_
#define INCLUDED_console_carbon_impl_h_

#include "console-impl.h"
#include "device-impl.h"
#include "frame-impl.h"

#ifdef HAVE_CARBON

#include <Carbon/Carbon.h>
#include <ApplicationServices/ApplicationServices.h>

DECLARE_CONSOLE_TYPE (carbon);

struct carbon_device
{
  CGColorSpaceRef color_space;
};

#define DEVICE_CARBON_DATA(d) DEVICE_TYPE_DATA (d, carbon)

#define DEVICE_CARBON_COLOR_SPACE(d) (DEVICE_CARBON_DATA (d)->color_space)

struct carbon_frame
{
  WindowRef window;
  CGContextRef context;
  HIViewRef main_view;
  MenuRef menubar;
};

#define FRAME_CARBON_DATA(f) FRAME_TYPE_DATA (f, carbon)

#define FRAME_CARBON_WINDOW(f) (FRAME_CARBON_DATA (f)->window)
#define FRAME_CARBON_CONTEXT(f) (FRAME_CARBON_DATA (f)->context)
#define FRAME_CARBON_MAIN_VIEW(f) (FRAME_CARBON_DATA (f)->main_view)
#define FRAME_CARBON_MENUBAR(f) (FRAME_CARBON_DATA (f)->menubar)

extern struct console_type *carbon_console_type;

#endif /* HAVE_CARBON */

#endif /* INCLUDED_console_carbon_impl_h_ */
