/*
 The following code is original work by me, except where noted with
 the comments "Taken from ..." or "Adapted from ...".  I now place
 it in the public domain.
 
 Andrew Choi.  Calgary, Canada, February 9, 2005. */

#ifndef INCLUDED_glyphs_carbon_h_
#define INCLUDED_glyphs_carbon_h_

#ifdef HAVE_CARBON

#include <Carbon/Carbon.h>

#include "glyphs.h"

/****************************************************************************
 *                         Image-Instance Object                            *
 ****************************************************************************/

struct carbon_image_instance_data
{
  CGImageRef *image_ref;
};

#define CARBON_IMAGE_INSTANCE_DATA(i) \
((struct carbon_image_instance_data *) (i)->data)

#define IMAGE_INSTANCE_CARBON_IMAGE_REF(i) \
(CARBON_IMAGE_INSTANCE_DATA (i)->image_ref[0])
#define IMAGE_INSTANCE_CARBON_IMAGE_REF_SLICE(i,slice) \
(CARBON_IMAGE_INSTANCE_DATA (i)->image_ref[slice])
#define IMAGE_INSTANCE_CARBON_IMAGE_REF_SLICES(i) \
(CARBON_IMAGE_INSTANCE_DATA (i)->image_ref)

#define XIMAGE_INSTANCE_CARBON_IMAGE_REF(i) \
IMAGE_INSTANCE_CARBON_IMAGE_REF (XIMAGE_INSTANCE (i))
#define XIMAGE_INSTANCE_CARBON_IMAGE_REF_SLICE(i, slice) \
IMAGE_INSTANCE_CARBON_IMAGE_REF_SLICE (XIMAGE_INSTANCE (i, slice))
#define XIMAGE_INSTANCE_CARBON_IMAGE_REF_SLICES(i) \
IMAGE_INSTANCE_CARBON_IMAGE_REF_SLICES (XIMAGE_INSTANCE (i))

#endif /* HAVE_CARBON */

#endif /* INCLUDED_glyphs_carbon_h_ */
