/*
 The following code is original work by me, except where noted with
 the comments "Taken from ..." or "Adapted from ...".  I now place
 it in the public domain.
 
 Andrew Choi.  Calgary, Canada, February 9, 2005. */

#ifndef INCLUDED_objects_carbon_impl_h_
#define INCLUDED_objects_carbon_impl_h_

#include "objects-impl.h"

#ifdef HAVE_CARBON

#include <Carbon/Carbon.h>

/*****************************************************************************
 Color-Instance
 ****************************************************************************/

struct carbon_color_instance_data
{
  CGColorRef color;
};

#define CARBON_COLOR_INSTANCE_DATA(c) ((struct carbon_color_instance_data *) ((c)->data))
#define COLOR_INSTANCE_CARBON_COLOR(c) (CARBON_COLOR_INSTANCE_DATA (c)->color)

#define RGB_TO_ULONG(r, g, b) (((r) << 16) | ((g) << 8) | (b))

#define RED_FROM_ULONG(color) ((color) >> 16)
#define GREEN_FROM_ULONG(color) (((color) >> 8) & 0xff)
#define BLUE_FROM_ULONG(color) ((color) & 0xff)

#define UNRECOGNIZED_COLOR 0xffffffff

/*****************************************************************************
 Font-Instance
 ****************************************************************************/

struct carbon_font_instance_data
{
  ATSUFontID font;
  Fixed size;
  Boolean bold;
  Boolean italic;
};

#define CARBON_FONT_INSTANCE_DATA(f) ((struct carbon_font_instance_data *) ((f)->data))
#define FONT_INSTANCE_CARBON_FONT(f) (CARBON_FONT_INSTANCE_DATA (f)->font)
#define FONT_INSTANCE_CARBON_SIZE(f) (CARBON_FONT_INSTANCE_DATA (f)->size)
#define FONT_INSTANCE_CARBON_BOLD(f) (CARBON_FONT_INSTANCE_DATA (f)->bold)
#define FONT_INSTANCE_CARBON_ITALIC(f) (CARBON_FONT_INSTANCE_DATA (f)->italic)

#endif /* HAVE_CARBON */

#endif /* INCLUDED_objects_carbon_impl_h_ */
